<?php

// -------------------------------------------------------------------------
// functions.php for 'Smallboxes Geeklog theme'
// Yoshinori Tahara as dengen
// http://www.trybase.com/~dengen/log/
// 2007.7.26
// -------------------------------------------------------------------------

//@@@@@ 常に表示されるブロックの名前に含まれるキーワードの設定
//@@@@@
//@@@@@ キーワード '.super' を任意のブロックのブロックIDの末尾に追加すると、
//@@@@@ そのブロックはスーパーブロックになります。(^^;
//@@@@@ スーパーブロックは、Geeklogシステムが２カラムレイアウトに遷移しても必ず表示されます。
//@@@@@ この機能を利用すると、$_CONF['show_right_blocks']の値にかかわらず、
//@@@@@ 常時、３カラムレイアウトを維持することが可能です。
//@@@@@ なお、'admin_block' と 'user_block' はスーパーブロックです。（もちろん変更可能です）
$_SUPER_BLOCK_WORD = array( 'admin_block', 'user_block', 'super' );

// for Debug
// $_CONF['advanced_editor']   = false;
// $_CONF['show_right_blocks'] = false; // default:false
// $_CONF['left_blocks_in_footer'] = 0; // default:0

if (strpos ($_SERVER['PHP_SELF'], 'functions.php') !== false) {
    die ('This file can not be used on its own!');
}

$_IMAGE_TYPE = 'png';

$result = DB_query ("SELECT onleft,name FROM {$_TABLES['blocks']} WHERE is_enabled = 1");
$nrows = DB_numRows ($result);
for ($i = 0; $i < $nrows; $i++) {
    $A = DB_fetchArray ($result);

//@@@@@ changed by dengen >>------------------------------------------------------------------------
//
//  if ($A['onleft'] == 1) {
//      $_BLOCK_TEMPLATE[$A['name']] = 'blockheader-left.thtml,blockfooter-left.thtml';
//  } else {
//      $_BLOCK_TEMPLATE[$A['name']] = 'blockheader-right.thtml,blockfooter-right.thtml';
//  }
//
//@@@@@ changed by dengen ||------------------------------------------------------------------------


    //ここの設定を変えると左右カラムのデフォルトのブロックスタイルを変更可能です。
    if ( $A['onleft'] == 1 ) {

        $boxtype = 'type3';       // 左カラムのデフォルトブロックスタイル

    } else {

        $boxtype = 'type1-blue';  // 右カラムのデフォルトブロックスタイル

    }

    $btype = explode( '.', $A['name'] ); // box type

    foreach ( $btype as $B )
    {
        switch( $B )
        {
            case 'admin_block':

                $boxtype = 'type0';
                break;

            case 'user_block':

                $boxtype = 'type1-silver';
                $boxtype = 'type0';
                break;

            case 'section_block':

                $boxtype = 'type1-green';
                break;

            case 'whats_new_block':

                $boxtype = 'type1-blue';
                break;


            case 'events_block':

                $boxtype = 'type1-blue';
                break;

            case 'older_stories':

                $boxtype = 'type1-blue';
                break;

            case 'menu':

                $boxtype = 'type0';
                break;

//実験開始 だめだ、admin_blockとかuser_blockとかは、別関数だ。
/*
            case 'normal_blue':
            case 'normal_green':
            case 'normal_purple':
            case 'normal_orange':
            case 'normal_red':
            case 'normal_gray':
            case 'normal_silver':

                $boxtype = 'type1';
                $_barray =  explode( '_', $B );
                $SBOXES_BOXCOLOR[$A['name']] = $_barray[1];

                break;

*/
//実験終了

            case 'normal':

                $boxtype = 'type1-blue';
                break;

            case 'normal_green':

                $boxtype = 'type1-green';
                break;

            case 'normal_purple':

                $boxtype = 'type1-purple';
                break;

            case 'normal_orange':

                $boxtype = 'type1-orange';
                break;

            case 'normal_red':

                $boxtype = 'type1-red';
                break;

            case 'normal_gray':

                $boxtype = 'type1-gray';
                break;

            case 'normal_silver':

                $boxtype = 'type1-silver';
                break;


            case 'simple':

                $boxtype = 'type3';
                break;

            case 'tab':
            case 'tab_blue':

                $boxtype = 'type5-blue';
                break;

            case 'tab_green':

                $boxtype = 'type5-green';
                break;

            case 'tab_orange':

                $boxtype = 'type5-orange';
                break;

            case 'tab_purple':

                $boxtype = 'type5-purple';
                break;

            case 'tab_red':

                $boxtype = 'type5-red';
                break;

            case 'tab_silver':

                $boxtype = 'type5-silver';
                break;

            case 'noframe':

                $boxtype = 'noframe';
                break;
        }
    }

    $_BLOCK_TEMPLATE[$A['name']] = 'blockheader-' . $boxtype . '.thtml,blockfooter-' . $boxtype . '.thtml';

//@@@@@ changed by dengen <<------------------------------------------------------------------------
}

$_BLOCK_TEMPLATE['_msg_block'] = 'blockheader-message.thtml,blockfooter-message.thtml';
$_BLOCK_TEMPLATE['customlogin'] = 'customlogin-header.thtml,customlogin-footer.thtml';
$_BLOCK_TEMPLATE['whats_related_block'] = 'blockheader-related.thtml,blockfooter-related.thtml';
$_BLOCK_TEMPLATE['story_options_block'] = 'blockheader-related.thtml,blockfooter-related.thtml';


//@@@@ ****************************************************************************************************
//@@@@ Smallboxes Geeklog Theme Engine
//@@@@ 2007/7/26 by dengen
//@@@@ lib-common.phpに定義されている COM_siteHeader, COM_siteFooter, COM_showBlocks,
//@@@@ COM_formatBlock, COM_renderMenu をベースにして
//@@@@ カスタム関数 [テーマ]_siteHeader, [テーマ]_siteFooter, 
//@@@@ smallboxes_showBlocks, smallboxes_formatBlock, smallboxes_renderMenu を定義しています。
//@@@@ ****************************************************************************************************

/**
* Returns the site header
*
* @param    string  $what       If 'none' then no left blocks are returned, if 'menu' (default) then right blocks are returned
* @param    string  $pagetitle  optional content for the page's <title>
* @param    string  $headercode optional code to go into the page's <head>
* @return   string              Formatted HTML containing the site header
* @see function COM_siteFooter
*
*/
$_TMP_WHAT = '';

function Smallboxes_type2_siteHeader( $what = 'menu', $pagetitle = '', $headercode = '' )
{
    global $_CONF, $_TABLES, $_USER, $LANG01, $LANG_BUTTONS, $LANG_CHARSET,
           $LANG_DIRECTION, $_IMAGE_TYPE, $topic, $_COM_VERBOSE;

    //@@@@@ 20050805,20060207 add youkoso xxx san ----->
    global $HTTP_POST_VARS, $HTTP_GET_VARS,$LANG_JPN;
    //@@@@@ 20050705,20060207 add youkoso xxx san  <-----

//@@@@@ added by dengen >>--------------------------------------------------------------------------

    global $_TMP_WHAT;

    $_TMP_WHAT = $what;

//@@@@@ added by dengen <<--------------------------------------------------------------------------


//@@@@@ changed by dengen >>------------------------------------------------------------------------
    // If the theme implemented this for us then call their version instead.
    //
    //$function = $_CONF['theme'] . '_siteHeader';
    //
    //if( function_exists( $function ))
    //{
    //    return $function( $what, $pagetitle );
    //}
    //
    // send out the charset header
//@@@@@ changed by dengen <<------------------------------------------------------------------------

    if( empty( $LANG_CHARSET )) {
        $charset = $_CONF['default_charset'];
        if( empty( $charset )) {
            $charset = 'iso-8859-1';
        }
    } else {
        $charset = $LANG_CHARSET;
    }
    header ('Content-Type: text/html; charset=' . $charset);

    // If we reach here then either we have the default theme OR
    // the current theme only needs the default variable substitutions

    $header = new Template( $_CONF['path_layout'] );
    $header->set_file( array(
        'header'        => 'header.thtml',
        'menuitem'      => 'menuitem.thtml',
        'menuitem_last' => 'menuitem_last.thtml',
        'menuitem_none' => 'menuitem_none.thtml',
        'leftblocks'    => 'leftblocks.thtml'
        ));

    // get topic if not on home page
    if( !isset( $_GET['topic'] ))
    {
        if( isset( $_GET['story'] ))
        {
            $sid = COM_applyFilter( $_GET['story'] );
        }
        elseif( isset( $_GET['sid'] ))
        {
            $sid = COM_applyFilter( $_GET['sid'] );
        }
        elseif( isset( $_POST['story'] ))
        {
            $sid = COM_applyFilter( $_POST['story'] );
        }
        if( empty( $sid ) && $_CONF['url_rewrite'] &&
                ( strpos( $_SERVER['PHP_SELF'], 'article.php' ) !== false ))
        {
            COM_setArgNames( array( 'story' ));
            $sid = COM_applyFilter( COM_getArgument( 'story' ));
        }
        if( !empty( $sid ))
        {
            $topic = DB_getItem( $_TABLES['stories'], 'tid', "sid='$sid'" );
        }
    }
    else
    {
        $topic = COM_applyFilter( $_GET['topic'] );
    }

    $feed_url = '';
    if( $_CONF['backend'] == 1 ) // add feed-link to header if applicable
    {
        $baseurl = SYND_getFeedUrl();

        $sql = 'SELECT format, filename, title FROM '
             . $_TABLES['syndication'] . " WHERE (header_tid = 'all')";
        if( !empty( $topic ))
        {
            $sql .= " OR (header_tid = '" . addslashes( $topic ) . "')";
        }
        $result = DB_query( $sql );
        $numRows = DB_numRows( $result );
        for( $i = 0; $i < $numRows; $i++ )
        {
            $A = DB_fetchArray( $result );
            if ( !empty( $A['filename'] ))
            {
                $format = explode( '-', $A['format'] );
                $format_type = strtolower( $format[0] );
                $format_name = ucwords( $format[0] );

                $feed_url .= '<link rel="alternate" type="application/'
                          . $format_type . '+xml" title="' . $format_name
                          . ' Feed: ' . $A['title'] . '" href="' . $baseurl
                          . $A['filename'] . '">' . LB;
            }
        }
    }
    $header->set_var( 'feed_url', $feed_url );

    if( empty( $pagetitle ) && isset( $_CONF['pagetitle'] ))
    {
        $pagetitle = $_CONF['pagetitle'];
    }
    if( empty( $pagetitle ))
    {
        if( empty( $topic ))
        {
            $pagetitle = $_CONF['site_slogan'];
        }
        else
        {
            $pagetitle = stripslashes( DB_getItem( $_TABLES['topics'], 'topic',
                                                   "tid = '$topic'" ));
        }
    }
    if( !empty( $pagetitle ))
    {
        $pagetitle = ' - ' . $pagetitle;
    }
    $header->set_var( 'page_title', $_CONF['site_name'] . $pagetitle );

    if( isset( $_CONF['advanced_editor'] ) && ( $_CONF['advanced_editor'] == 1 )
            && file_exists( $_CONF['path_layout']
                            . 'advanced_editor_header.thtml' ))
    {
        $header->set_file( 'editor'  , 'advanced_editor_header.thtml');
        $header->parse( 'advanced_editor', 'editor' );

    }
    else
    {
         $header->set_var( 'advanced_editor', '' );
    }

    $header->set_var( 'background_image', $_CONF['layout_url']
                                          . '/images/bg.' . $_IMAGE_TYPE );
    $header->set_var( 'site_url', $_CONF['site_url'] );
    $header->set_var( 'layout_url', $_CONF['layout_url'] );
    $header->set_var( 'site_mail', "mailto:{$_CONF['site_mail']}" );
    $header->set_var( 'site_name', $_CONF['site_name'] );
    $header->set_var( 'site_slogan', $_CONF['site_slogan'] );
    $rdf = substr_replace( $_CONF['rdf_file'], $_CONF['site_url'], 0,
                           strlen( $_CONF['path_html'] ) - 1 );
    $header->set_var( 'rdf_file', $rdf );
    $header->set_var( 'rss_url', $rdf );

    //@@@@@ 20050805,20060207 update youkoso xxx san  ----->
    //               youkoso xxxx san
    //$msg = $LANG01[67] . ' ' . $_CONF['site_name'];
    //if( !empty( $_USER['username'] ))
    //{
    //    $msg .= ', ' . $_USER['username'];
    //}
    $msg = $LANG01[67];
    if( !empty( $_USER['username'] ))
    {
        $msg .= ' ' . $_USER['username'].$LANG_JPN[1];
    }
    //@@@@@ 20050805,20060207 update youkoso xxx san   <-----

    $curtime =  COM_getUserDateTimeFormat();

    $header->set_var( 'welcome_msg', $msg );
    $header->set_var( 'datetime', $curtime[0] );
    $header->set_var( 'site_logo', $_CONF['layout_url']
                                   . '/images/logo.' . $_IMAGE_TYPE );
    $header->set_var( 'css_url', $_CONF['layout_url'] . '/style.css' );
    $header->set_var( 'theme', $_CONF['theme'] );

    if( empty( $LANG_CHARSET ))
    {
        $charset = $_CONF['default_charset'];

        if( empty( $charset ))
        {
            $charset = 'iso-8859-1';
        }
    }
    else
    {
        $charset = $LANG_CHARSET;
    }

    $header->set_var( 'charset', $charset );
    if( empty( $LANG_DIRECTION ))
    {
        // default to left-to-right
        $header->set_var( 'direction', 'ltr' );
    }
    else
    {
        $header->set_var( 'direction', $LANG_DIRECTION );
    }

    // Now add variables for buttons like e.g. those used by the Yahoo theme
    $header->set_var( 'button_home', $LANG_BUTTONS[1] );
    $header->set_var( 'button_contact', $LANG_BUTTONS[2] );
    $header->set_var( 'button_contribute', $LANG_BUTTONS[3] );
    $header->set_var( 'button_calendar', $LANG_BUTTONS[6] );
    $header->set_var( 'button_sitestats', $LANG_BUTTONS[7] );
    $header->set_var( 'button_personalize', $LANG_BUTTONS[8] );
    $header->set_var( 'button_search', $LANG_BUTTONS[9] );
    $header->set_var( 'button_advsearch', $LANG_BUTTONS[10] );
    $header->set_var( 'button_directory', $LANG_BUTTONS[11] );

    // Get plugin menu options
    $plugin_menu = PLG_getMenuItems();

    if( $_COM_VERBOSE )
    {
        COM_errorLog( 'num plugin menu items in header = ' . count( $plugin_menu ), 1 );
    }

//@@@@@ added by dengen >>--------------------------------------------------------------------------

//    $_CONF['menu_elements'] = array_reverse( $_CONF['menu_elements'] );//逆順にする
//    $plugin_menu = array_reverse( $plugin_menu );                      //逆順にする
    //カスタムメニューエントリーには対応しない。(lib-custum.phpのCUSTOM_menuEntries()で対応できる)

//@@@@@ added by dengen <<--------------------------------------------------------------------------

    // Now add nested template for menu items
//    COM_renderMenu( $header, $plugin_menu );
    smallboxes_renderMenu( $header, $plugin_menu );

//@@@@@ added by dengen >>--------------------------------------------------------------------------
    smallboxes_renderSubmenu( $header );
//@@@@@ added by dengen <<--------------------------------------------------------------------------

//@@@@@ added by dengen >>--------------------------------------------------------------------------

//    $plugin_menu = array_reverse( $plugin_menu );                      //元の順に戻す
//    $_CONF['menu_elements'] = array_reverse( $_CONF['menu_elements'] );//元の順に戻す

//@@@@@ added by dengen <<--------------------------------------------------------------------------

    if( count( $plugin_menu ) == 0 )
    {
        $header->parse( 'plg_menu_elements', 'menuitem_none', true );
    }
    else
    {
        for( $i = 1; $i <= count( $plugin_menu ); $i++ )
        {

//@@@@@ added by dengen >>--------------------------------------------------------------------------
            $header->set_var( 'menuitem_selected',  menu_selected( current( $plugin_menu ), key( $plugin_menu ) ) );
//@@@@@ added by dengen <<--------------------------------------------------------------------------

            $header->set_var( 'menuitem_url', current( $plugin_menu ));
            $header->set_var( 'menuitem_text', key( $plugin_menu ));

            if( $i == count( $plugin_menu ))
            {
                $header->parse( 'plg_menu_elements', 'menuitem_last', true );
            }
            else
            {
                $header->parse( 'plg_menu_elements', 'menuitem', true );
            }

            next( $plugin_menu );
        }
    }


//@@@@@ changed by dengen >>------------------------------------------------------------------------
/*
    if( $_CONF['left_blocks_in_footer'] == 1 )
    {
        $header->set_var( 'geeklog_blocks', '' );
        $header->set_var( 'left_blocks', '' );
    }
    else
    {
        $lblocks = '';
*/
        /* Check if an array has been passed that includes the name of a plugin
         * function or custom function
         * This can be used to take control over what blocks are then displayed
         */
/*
        if( is_array( $what ))
        {
            $function = $what[0];
            if( function_exists( $function ))
            {
                $lblocks = $function( $what[1], 'left' );
            }
        }
        else if( $what <> 'none' )
        {
            // Now show any blocks -- need to get the topic if not on home page
            $lblocks = COM_showBlocks( 'left', $topic );
        }

        if( empty( $lblocks ))
        {
            $header->set_var( 'geeklog_blocks', '' );
            $header->set_var( 'left_blocks', '' );
        }
        else
        {
            $header->set_var( 'geeklog_blocks', $lblocks );
            $header->parse( 'left_blocks', 'leftblocks', true );
        }
    }
*/
//@@@@@ changed by dengen <<------------------------------------------------------------------------

    // Call any plugin that may want to include extra Meta tags
    // or Javascript functions
    $header->set_var( 'plg_headercode', $headercode . PLG_getHeaderCode() );

    // Call to plugins to set template variables in the header
    PLG_templateSetVars( 'header', $header );

    // The following lines allow users to embed PHP in their templates.  This
    // is almost a contradition to the reasons for using templates but this may
    // prove useful at times ...
    // Don't use PHP in templates if you can live without it!

    $tmp = $header->parse( 'index_header', 'header' );

    ob_start();
    eval( '?>' . $tmp );
    $retval = ob_get_contents();
    ob_end_clean();

    return $retval;
}


/**
* Returns the site footer
*
* @param   boolean     $rightblock     Whether or not to show blocks on right hand side default is no
*                                      右ブロックを表示させるかどうか。デフォルトは表示させない。
* @param   array       $custom         An array defining custom function to be used to format Rightblocks
* @see function COM_siteHeader
* @return   string  Formated HTML containing site footer and optionally right blocks
*
*/
function Smallboxes_type2_siteFooter( $rightblock = false, $custom = '' )
{
    global $_CONF, $_TABLES, $LANG01, $_PAGE_TIMER, $topic;

//@@@@@ added by dengen >>--------------------------------------------------------------------------

    global $LANG_BUTTONS, $_TMP_WHAT, $smallboxes_title;

//@@@@@ added by dengen <<--------------------------------------------------------------------------


//@@@@@ changed by dengen >>------------------------------------------------------------------------
//  if( $rightblock < 0 )
//  {
//      if( isset( $_CONF['show_right_blocks'] ))
//      {
//          $rightblock = $_CONF['show_right_blocks'];
//      }
//      else
//      {
//          $rightblock = false;
//      }
//  }
//@@@@@ changed by dengen ||------------------------------------------------------------------------
//
//  ここでは、左右にかかわらず
//    $rightblock = true  のとき、両サイドバーブロックを表示させる
//    $rightblock = false のとき、片方のみサイドバーブロックを表示させる
//  と解釈して処理する。
    if( !$rightblock )
    {
        if( isset( $_CONF['show_right_blocks'] ))
        {
            $rightblock = $_CONF['show_right_blocks'];
        }
    }
//@@@@@ changed by dengen <<------------------------------------------------------------------------

//@@@@@ changed by dengen >>------------------------------------------------------------------------
    // If the theme implemented this for us then call their version instead.
    //
    //$function = $_CONF['theme'] . '_siteFooter';
    //
    //if( function_exists( $function ))
    //{
    //    return $function( $rightblock );
    //}
//@@@@@ changed by dengen <<------------------------------------------------------------------------

    // Set template directory
    $footer = new Template( $_CONF['path_layout'] );

    // Set template file
    $footer->set_file( array(
            'footer'      => 'footer.thtml',
            'rightblocks' => 'rightblocks.thtml',
//@@@@@ added by dengen >>------------------------------------------------------------------------
            'menuitem'      => 'menuitem.thtml',
            'menuitem_last' => 'menuitem_last.thtml',
            'menuitem_none' => 'menuitem_none.thtml',
//@@@@@ added by dengen <<------------------------------------------------------------------------
            'leftblocks'  => 'leftblocks.thtml'
            ));

    // Do variable assignments
    DB_change( $_TABLES['vars'], 'value', 'value + 1', 'name', 'totalhits', '', true );

    $footer->set_var( 'site_url', $_CONF['site_url']);
    $footer->set_var( 'layout_url',$_CONF['layout_url']);
    $footer->set_var( 'site_mail', "mailto:{$_CONF['site_mail']}" );
    $footer->set_var( 'site_name', $_CONF['site_name'] );
    $footer->set_var( 'site_slogan', $_CONF['site_slogan'] );
    $rdf = substr_replace( $_CONF['rdf_file'], $_CONF['site_url'], 0,
                           strlen( $_CONF['path_html'] ) - 1 );
    $footer->set_var( 'rdf_file', $rdf );
    $footer->set_var( 'rss_url', $rdf );

    $year = date( 'Y' );
    $copyrightyear = $year;
    if( !empty( $_CONF['copyrightyear'] ))
    {
        $copyrightyear = $_CONF['copyrightyear'];
    }
    
    $footer->set_var( 'copyright_notice', '&nbsp;' . $LANG01[93] . ' &copy; '
            . $copyrightyear . ' ' . $_CONF['site_name'] . '<br>&nbsp;'
            . $LANG01[94] );
    $footer->set_var( 'copyright_msg', $LANG01[93] . ' &copy; '
            . $copyrightyear . ' ' . $_CONF['site_name'] );
    $footer->set_var( 'current_year', $year );
    $footer->set_var( 'lang_copyright', $LANG01[93] );
    $footer->set_var( 'trademark_msg', $LANG01[94] );
    $footer->set_var( 'powered_by', $LANG01[95] );
    $footer->set_var( 'geeklog_url', 'http://www.geeklog.net/' );
    $footer->set_var( 'geeklog_version', VERSION );


//@@@@@ added by dengen >>--------------------------------------------------------------------------

    // Now add variables for buttons like e.g. those used by the Yahoo theme
    $footer->set_var( 'button_home',        $LANG_BUTTONS[1]  );
    $footer->set_var( 'button_contact',     $LANG_BUTTONS[2]  );
    $footer->set_var( 'button_contribute',  $LANG_BUTTONS[3]  );
    $footer->set_var( 'button_calendar',    $LANG_BUTTONS[6]  );
    $footer->set_var( 'button_sitestats',   $LANG_BUTTONS[7]  );
    $footer->set_var( 'button_personalize', $LANG_BUTTONS[8]  );
    $footer->set_var( 'button_search',      $LANG_BUTTONS[9]  );
    $footer->set_var( 'button_advsearch',   $LANG_BUTTONS[10] );
    $footer->set_var( 'button_directory',   $LANG_BUTTONS[11] );

    // Get plugin menu options
    $plugin_menu = PLG_getMenuItems();

    if( $_COM_VERBOSE )
    {
        COM_errorLog( 'num plugin menu items in footer = ' . count( $plugin_menu ), 1 );
    }

    // Now add nested template for menu items
//    COM_renderMenu( $footer, $plugin_menu );
    smallboxes_renderMenu( $footer, $plugin_menu );

    if( count( $plugin_menu ) == 0 )
    {
        $header->parse( 'plg_menu_elements', 'menuitem_none', true );
    }
    else
    {
        for( $i = 1; $i <= count( $plugin_menu ); $i++ )
        {

            $footer->set_var( 'menuitem_selected',  menu_selected( current( $plugin_menu ), key( $plugin_menu ) ) );

            $footer->set_var( 'menuitem_url', current( $plugin_menu ));
            $footer->set_var( 'menuitem_text', key( $plugin_menu ));

            if( $i == count( $plugin_menu ))
            {
                $footer->parse( 'plg_menu_elements', 'menuitem_last', true );
            }
            else
            {
                $footer->parse( 'plg_menu_elements', 'menuitem', true );
            }

            next( $plugin_menu );
        }
    }

//@@@@@ added by dengen <<--------------------------------------------------------------------------

    /* Check if an array has been passed that includes the name of a plugin
     * function or custom function.
     * This can be used to take control over what blocks are then displayed
     */
    if( is_array( $custom ))
    {
        $function = $custom['0'];
        if( function_exists( $function ))
        {
            $rblocks = $function( $custom['1'], 'right' );
        }
    }
//@@@@@ changed by dengen >>------------------------------------------------------------------------
/*
    elseif( $rightblock )
    {
        $rblocks = COM_showBlocks( 'right', $topic );
    }

    if( $rightblock && !empty( $rblocks ))
    {
        $footer->set_var( 'geeklog_blocks', $rblocks );
        $footer->parse( 'right_blocks', 'rightblocks', true );
    }
    else
    {
        $footer->set_var( 'geeklog_blocks', '' );
        $footer->set_var( 'right_blocks', '' );
    }
*/
//@@@@@ changed by dengen ||------------------------------------------------------------------------

    else if( $_TMP_WHAT <> 'none' )
    {
        $rblocks = smallboxes_showBlocks( 'right', $topic, $rightblock );
    }

    if( !empty( $rblocks ) )
    {
        $footer->set_var( 'geeklog_blocks', $rblocks );
        $footer->parse( 'right_blocks', 'rightblocks', true );
    }
    else
    {
        $footer->set_var( 'geeklog_blocks', '' );
        $footer->set_var( 'right_blocks', '' );
    }

//@@@@@ changed by dengen <<------------------------------------------------------------------------



//@@@@@ changed by dengen >>------------------------------------------------------------------------
/*
    if( $_CONF['left_blocks_in_footer'] == 1 )
    {
        $lblocks = '';
*/
        /* Check if an array has been passed that includes the name of a plugin
         * function or custom function
         * This can be used to take control over what blocks are then displayed
         */
/*
        if( is_array( $custom ))
        {
            $function = $custom[0];
            if( function_exists( $function ))
            {
                $lblocks = $function( $custom[1], 'left' );
            }
        }
        else
        {
            $lblocks = COM_showBlocks( 'left', $topic );
        }
*/
//@@@@@ changed by dengen ||------------------------------------------------------------------------

        $lblocks = '';

        if( is_array( $_TMP_WHAT ))
        {
            $function = $_TMP_WHAT[0];
            if( function_exists( $function ))
            {
                $lblocks = $function( $_TMP_WHAT[1], 'left' );
            }
        }
        else if( $_TMP_WHAT <> 'none' )
        {
            $lblocks = smallboxes_showBlocks( 'left', $topic, $rightblock );
        }

//@@@@@ changed by dengen <<------------------------------------------------------------------------

        if( empty( $lblocks ))
        {
            $footer->set_var( 'geeklog_blocks', '' );
            $footer->set_var( 'left_blocks', '' );
        }
        else
        {
            $footer->set_var( 'geeklog_blocks', $lblocks );
            $footer->parse( 'left_blocks', 'leftblocks', true );
        }

//@@@@@ changed by dengen >>------------------------------------------------------------------------
//  }
//@@@@@ changed by dengen <<------------------------------------------------------------------------

    // Global centerspan variable set in index.php
    if( isset( $GLOBALS['centerspan'] ))
    {
        $footer->set_var( 'centerblockfooter-span', '</td></tr></table>' );
    }

    $exectime = $_PAGE_TIMER->stopTimer();
    $exectext = $LANG01[91] . ' ' . $exectime . ' ' . $LANG01[92];

    $footer->set_var( 'execution_time', $exectime );
    $footer->set_var( 'execution_textandtime', $exectext );

    // Call to plugins to set template variables in the footer
    PLG_templateSetVars( 'footer', $footer );

    // Actually parse the template and make variable substitutions
    $footer->parse( 'index_footer', 'footer' );

    // Return resulting HTML
    return $footer->finish( $footer->get_var( 'index_footer' ));
}


/**
* Shows Geeklog blocks
*
* Returns HTML for blocks on a given side and, potentially, for
* a given topic. Currentlly only used by static pages.
*
* @param        string      $side       Side to get blocks for (right or left for now)
* @param        string      $topic      Only get blocks for this topic
* @param        string      $name       Block name (not used)
* @see function COM_showBlock
* @return   string  HTML Formated blocks
*
*/

function smallboxes_showBlocks( $side, $topic='', $isshow=true, $name='all' )
{
      global $_CONF, $_TABLES, $_USER, $LANG21, $topic, $page, $newstories;

//@@@@@ added by dengen >>--------------------------------------------------------------------------

      global $_SUPER_BLOCK_WORD;

//@@@@@ added by dengen <<--------------------------------------------------------------------------

    $retval = '';

    // Get user preferences on blocks
    if( !isset( $_USER['noboxes'] ) || !isset( $_USER['boxes'] ))
    {
        if( !empty( $_USER['uid'] ))
        {
            $result = DB_query( "SELECT boxes,noboxes FROM {$_TABLES['userindex']} "
                               ."WHERE uid = '{$_USER['uid']}'" );
            list($_USER['boxes'], $_USER['noboxes']) = DB_fetchArray( $result );
        }
        else
        {
            $_USER['boxes'] = '';
            $_USER['noboxes'] = 0;
        }
    }

    if( $side == 'left' )
    {
        $sql = "SELECT *,UNIX_TIMESTAMP(rdfupdated) as date "
              ."FROM {$_TABLES['blocks']} WHERE onleft = 1 AND is_enabled = 1";
    }
    else
    {
        $sql = "SELECT *,UNIX_TIMESTAMP(rdfupdated) as date "
              ."FROM {$_TABLES['blocks']} WHERE onleft = 0 AND is_enabled = 1";
    }

    if( !empty( $topic ))
    {
        $sql .= " AND (tid = '$topic' OR (tid = 'all' AND type <> 'layout'))";
    }
    else
    {

        if( COM_isFrontpage() )
        {
            $sql .= " AND (tid = 'all' AND type <> 'layout')";
        }
        else
        {
            $sql .= " AND (tid = 'homeonly' OR (tid = 'all' AND type <> 'layout'))";
        }

    }

    if( !empty( $_USER['boxes'] ))
    {
        $BOXES = str_replace( ' ', ',', $_USER['boxes'] );

        $sql .= " AND (bid NOT IN ($BOXES) OR bid = '-1')";
    }

    $sql .= ' ORDER BY blockorder,title asc';

    $result = DB_query( $sql );
    $nrows = DB_numRows( $result );

    // convert result set to an array of associated arrays
    $blocks = array();
    for( $i = 1; $i <= $nrows; $i++ )
    {
        $blocks[] = DB_fetchArray( $result );
    }

    // Check and see if any plugins have blocks to show
    $pluginBlocks = PLG_getBlocks( $side, $topic, $name );
    $blocks = array_merge( $blocks, $pluginBlocks );


//@@@@@ added by dengen >>------------------------------------------------------------------------

    $exist_superblock = false;
    foreach( $blocks as $A )
    {
        $bword = explode( '.', $A['name'] );
        foreach( $_SUPER_BLOCK_WORD as $B )
        {
            if ( in_array( $B, $bword ) )
            {
                $exist_superblock = true;
            }
        }
    }

    if ( !$isshow && !$exist_superblock )
    {
        return '';
    }

//@@@@@ added by dengen <<------------------------------------------------------------------------

    // sort the resulting array by block order
    $column = 'blockorder';
    $sortedBlocks = $blocks;
    for( $i = 0; $i < sizeof( $sortedBlocks )-1; $i++ )
    {
        for ($j=0; $j<sizeof($sortedBlocks)-1-$i; $j++)
        {
            if ($sortedBlocks[$j][$column] > $sortedBlocks[$j+1][$column])
            {
                $tmp = $sortedBlocks[$j];
                $sortedBlocks[$j] = $sortedBlocks[$j + 1];
                $sortedBlocks[$j + 1] = $tmp;
            }
        }
    }
    $blocks = $sortedBlocks;

    // Loop though resulting sorted array and pass associative arrays to COM_formatBlock
    foreach( $blocks as $A )
    {
        if( SEC_hasAccess( $A['owner_id'], $A['group_id'], $A['perm_owner'], $A['perm_group'], $A['perm_members'], $A['perm_anon']) > 0 or $A['type'] == 'dynamic' )
        {
// changeed by dengen ------------------------>>
             $retval .= COM_formatBlock( $A, $_USER['noboxes'] );
// changeed by dengen ------------------------||
//           $retval .= smallboxes_formatBlock( $A, $_USER['noboxes'] );
// changeed by dengen ------------------------<<
        }
    }

    return $retval;
}


/**
* Formats a Geeklog block
*
* This shows a single block and is typically called from
* COM_showBlocks OR from plugin code
*
* @param        array     $A          Block Record
* @param        bool      $noboxes    Set to true if userpref is no blocks
* @return       string    HTML Formated block
*
*/
function smallboxes_formatBlock( $A, $noboxes = false )
{
    global $_CONF, $_TABLES, $_USER, $LANG21, $SBOXES_BOXCOLOR;

    $retval = '';
    if( $A['type'] == 'portal' )
    {
        if( COM_rdfCheck( $A['bid'], $A['rdfurl'], $A['date'], $A['rdflimit'] ))
        {
            $A['content'] = DB_getItem( $_TABLES['blocks'], 'content', "bid = '{$A['bid']}'");
        }
    }

    if( $A['type'] == 'gldefault' )
    {
        $retval .= COM_showBlock( $A['name'], $A['help'], $A['title'] );
    }

    if( $A['type'] == 'phpblock' && !$noboxes )
    {
        if( !( $A['name'] == 'whosonline_block' AND DB_getItem( $_TABLES['blocks'], 'is_enabled', "name='whosonline_block'" ) == 0 ))
        {
            $function = $A['phpblockfn'];
// changeed by dengen ------------------------>>
//          $blkheader = COM_startBlock( $A['title'], $A['help'], COM_getBlockTemplate( $A['name'], 'header' ));
// changeed by dengen ------------------------||
            $blkheader = smallboxes_startBlock( $A['title'], $A['help'], COM_getBlockTemplate( $A['name'], 'header' ), $SBOXES_BOXCOLOR[ $A['name'] ] );
// changeed by dengen ------------------------<<

            $blkfooter = COM_endBlock( COM_getBlockTemplate( $A['name'], 'footer' ));

            if( function_exists( $function ))
            {
                $fretval = $function();
                if( !empty( $fretval ))
                {
                    $retval .= $blkheader;
                    $retval .= $fretval;
                    $retval .= $blkfooter;
                }
            }
            else
            {
                // show error message
                $retval .= $blkheader;
                $retval .= sprintf( $LANG21[31], $function );
                $retval .= $blkfooter;
            }
        }
    }

    if( !empty( $A['content'] ) && ( trim( $A['content'] ) != '' ) && !$noboxes )
    {
        $blockcontent = stripslashes( $A['content'] );

        // Hack: If the block content starts with a '<' assume it
        // contains HTML and do not call nl2br() which would only add
        // unwanted <br> tags.

        if( substr( $blockcontent, 0, 1 ) != '<' )
        {
            $blockcontent = nl2br( $blockcontent );
        }

        if ($A['allow_autotags'] == 1) {
            $blockcontent = PLG_replaceTags( $blockcontent );
        }
        $blockcontent = str_replace( array( '<?', '?>' ), '', $blockcontent );

// changeed by dengen ------------------------>>
//      $retval .= COM_startBlock( $A['title'], $A['help'], COM_getBlockTemplate( $A['name'], 'header' ))
// changeed by dengen ------------------------||
        $retval .= smallboxes_startBlock( $A['title'], $A['help'], COM_getBlockTemplate( $A['name'], 'header'), $SBOXES_BOXCOLOR[ $A['name'] ] )
// changeed by dengen ------------------------<<
                . $blockcontent . LB
                . COM_endBlock( COM_getBlockTemplate( $A['name'], 'footer' ));
    }

    return $retval;
}

/**
* Prints out standard block header
*
* Prints out standard block header but pulling header HTML formatting from
* the database.
*
* Programming Note:  The two functions COM_startBlock and COM_endBlock are used
* to sandwich your block content.  These functions are not used only for blocks
* but anything that uses that format, e.g. Stats page.  They are used like
* COM_siteHeader and COM_siteFooter but for internal page elements.
*
*
* @param        string      $title      Value to set block title to
* @param        string      $helpfile   Help file, if one exists
* @param        string      $template   HTML template file to use to format the block
* @see COM_endBlock
* @see COM_siteHeader  For similiar construct
* @return   string  Formatted HTML containing block header
*
*/

function smallboxes_startBlock( $title='', $helpfile='', $template='blockheader.thtml', $box_color='default' )
{
    global $_CONF, $LANG01, $_IMAGE_TYPE;

    $block = new Template( $_CONF['path_layout'] );
    $block->set_file( 'block', $template );

    $block->set_var( 'site_url', $_CONF['site_url'] );
    $block->set_var( 'layout_url', $_CONF['layout_url'] );
    $block->set_var( 'block_title', stripslashes( $title ));
// added by dengen ------------------------>>
    $block->set_var( 'block_color', $box_color);
// added by dengen ------------------------<<

    if( !empty( $helpfile ))
    {
        $helpimg = $_CONF['layout_url'] . '/images/button_help.' . $_IMAGE_TYPE;
        if( !stristr( $helpfile, 'http://' ))
        {
            $help = '<a class="blocktitle" href="' . $_CONF['site_url'] . '/help/' . $helpfile
                . '" target="_blank"><img src="' . $helpimg
                . '" border="0" alt="?"></a>';
        }
        else
        {
            $help = '<a class="blocktitle" href="' . $helpfile
                . '" target="_blank"><img src="' . $helpimg
                . '" border="0" alt="?"></a>';
        }

        $block->set_var( 'block_help', $help );
    }

    $block->parse( 'startHTML', 'block' );

    return $block->finish( $block->get_var( 'startHTML' ));
}




/**
* Create the menu, i.e. replace {menu_elements} in the site header with the
* actual menu entries.
*
* @param    Template    $header     reference to the header template
* @param    array       $plugin_menu    array of plugin menu entries, if any
*
*/
function smallboxes_renderMenu( &$header, $plugin_menu )
{
    global $_CONF, $_USER, $LANG01, $topic;

    if( empty( $_CONF['menu_elements'] ))
    {
        $_CONF['menu_elements'] = array( // default set of links
                'contribute', 'calendar', 'search', 'stats',
                'directory', 'plugins' );
    }

    $anon = ( empty( $_USER['uid'] ) || ( $_USER['uid'] <= 1 )) ? true : false;
    $menuCounter = 0;
    $allowedCounter = 0;
    $counter = 0;

    $num_plugins = sizeof( $plugin_menu );
    if( ( $num_plugins == 0 ) && in_array( 'plugins', $_CONF['menu_elements'] ))
    {
        $key = array_search( 'plugins', $_CONF['menu_elements'] );
        unset( $_CONF['menu_elements'][$key] );
    }

    if( in_array( 'custom', $_CONF['menu_elements'] ))
    {
        $custom_entries = array();
        if( function_exists( 'CUSTOM_menuEntries' ))
        {
            $custom_entries = CUSTOM_menuEntries();
        }
        if( sizeof( $custom_entries ) == 0 )
        {
            $key = array_search( 'custom', $_CONF['menu_elements'] );
            unset( $_CONF['menu_elements'][$key] );
        }
    }

    $num_elements = sizeof( $_CONF['menu_elements'] );

    foreach( $_CONF['menu_elements'] as $item )
    {
        $counter++;
        $allowed = true;
        $last_entry = ( $counter == $num_elements ) ? true : false;

        switch( $item )
        {
            case 'calendar':
                $url = $_CONF['site_url'] . '/calendar.php';
                $label = $LANG01[74];
                if( $anon && ( $_CONF['loginrequired'] || $_CONF['calendarloginrequired'] ))
                {
                    $allowed = false;
                }
                break;

            case 'contribute':
                if( empty( $topic ))
                {
                    $url = $_CONF['site_url'] . '/submit.php?type=story';
                    $header->set_var( 'current_topic', '' );
                }
                else
                {
                    $url = $_CONF['site_url']
                         . '/submit.php?type=story&amp;topic=' . $topic;
                    $header->set_var( 'current_topic', '&amp;topic=' . $topic );
                }
                $label = $LANG01[71];
                if( $anon && ( $_CONF['loginrequired'] || $_CONF['submitloginrequired'] ))
                {
                    $allowed = false;
                }
                break;

            case 'custom':
                $custom_count = 0;
                $custom_size = sizeof( $custom_entries );
                foreach( $custom_entries as $entry )
                {
                    $custom_count++;

                    if( empty( $entry['url'] ) || empty( $entry['label'] ))
                    {
                        continue;
                    }

//@@@@@ added by dengen >>------------------------------------------------------------------------

                    $header->set_var( 'menuitem_selected',  menu_selected( $entry['url'], $entry['label'] ) );

//@@@@@ added by dengen <<------------------------------------------------------------------------

                    $header->set_var( 'menuitem_url',  $entry['url'] );
                    $header->set_var( 'menuitem_text', $entry['label'] );

                    if( $last_entry && ( $custom_count == $custom_size ))
                    {
                        $header->parse( 'menu_elements', 'menuitem_last', true );
                    }
                    else
                    {
                        $header->parse( 'menu_elements', 'menuitem', true );
                    }
                    $menuCounter++;
                }
                $url = '';
                $label = '';
                break;

            case 'directory':
                $url = $_CONF['site_url'] . '/directory.php';
                if( !empty( $topic ))
                {
                    $url = COM_buildUrl( $url . '?topic=' . urlencode( $topic ));
                }
                $label = $LANG01[117];
                if( $anon && ( $_CONF['loginrequired'] || $_CONF['directoryloginrequired'] ))
                {
                    $allowed = false;
                }
                break;

            case 'home':
                $url = $_CONF['site_url'] . '/';
                $label = $LANG01[90];
                break;

            case 'plugins':
                for( $i = 1; $i <= $num_plugins; $i++ )
                {
//@@@@@ added by dengen >>------------------------------------------------------------------------

                    $header->set_var( 'menuitem_selected',  menu_selected( current( $plugin_menu ), key( $plugin_menu ) ) );

//@@@@@ added by dengen <<------------------------------------------------------------------------

                    $header->set_var( 'menuitem_url', current( $plugin_menu ));
                    $header->set_var( 'menuitem_text', key( $plugin_menu ));

                    if( $last_entry && ( $i == $num_plugins ))
                    {
                        $header->parse( 'menu_elements', 'menuitem_last', true );
                    }
                    else
                    {
                        $header->parse( 'menu_elements', 'menuitem', true );
                    }
                    $menuCounter++;

                    next( $plugin_menu );
                }
                $url = '';
                $label = '';
                break;

            case 'prefs':
                $url = $_CONF['site_url'] . '/usersettings.php?mode=edit';
                $label = $LANG01[48];
                break;

            case 'search':
                $url = $_CONF['site_url'] . '/search.php';
                $label = $LANG01[75];
                if( $anon && ( $_CONF['loginrequired'] || $_CONF['searchloginrequired'] ))
                {
                    $allowed = false;
                }
                break;

            case 'stats':
                $url = $_CONF['site_url'] . '/stats.php';
                $label = $LANG01[76];
                if( $anon &&
                    ( $_CONF['loginrequired'] || $_CONF['statsloginrequired'] ))
                {
                    $allowed = false;
                }
                break;

            default: // unknown entry
                $url = '';
                $label = '';
                break;
        }

        if( !empty( $url ) && !empty( $label ))
        {
//@@@@@ added by dengen >>------------------------------------------------------------------------

            $header->set_var( 'menuitem_selected',  menu_selected( $url, $label ) );

//@@@@@ added by dengen <<------------------------------------------------------------------------

            $header->set_var( 'menuitem_url',  $url );
            $header->set_var( 'menuitem_text', $label );
            if( $last_entry )
            {
                $header->parse( 'menu_elements', 'menuitem_last', true );
            }
            else
            {
                $header->parse( 'menu_elements', 'menuitem', true );
            }
            $menuCounter++;

            if( $allowed )
            {
                if( $last_entry )
                {
                    $header->parse( 'allowed_menu_elements', 'menuitem_last', true );
                }
                else
                {
                    $header->parse( 'allowed_menu_elements', 'menuitem', true );
                }
                $allowedCounter++;
            }
        }
    }

    if( $menuCounter == 0 )
    {
        $header->parse( 'menu_elements', 'menuitem_none', true );
    }
    if( $allowedCounter == 0 )
    {
        $header->parse( 'allowed_menu_elements', 'menuitem_none', true );
    }
}

function menu_selected( &$url, $key )
{
    $str = "";
    if ( ( ! strpos( $url . 'index.php' , $_SERVER['HTTP_HOST'] . $_SERVER["PHP_SELF"] ) === false ) ||
         ( ! strpos( $url , $_SERVER['HTTP_HOST'] . $_SERVER["PHP_SELF"] ) === false ) ) {
        $str = "selected";
        $GLOBALS['Submenukey'] = $key;
    }
    return $str;
}

function smallboxes_renderSubmenu( &$header )
{
    $submenuEntries = array();
    if( function_exists( 'CUSTOM_submenuEntries' ))
        $submenuEntries = CUSTOM_submenuEntries();
    if( sizeof( $submenuEntries ) > 0 )
    {
        $key = $GLOBALS['Submenukey'];
        $function = $submenuEntries[$key];
        if ( function_exists($function) ) {
            $header->set_var( 'sub_menu_elements', $function() );
            $header->set_var( 'sub_menu_visible', '' );
        } else {
            $header->set_var( 'sub_menu_elements', '' );
            $header->set_var( 'sub_menu_visible', '_hidden' );
        }
    } else {
        $header->set_var( 'sub_menu_elements', '' );
        $header->set_var( 'sub_menu_visible', '_hidden' );
    }
}


?>
